managements/urls.py
from django.conf.urls import url, include
from django.views.generic import TemplateView
from . import views

urlpatterns = [
    url(r'^$', views.IndexView.as_view(), name='management-index'),
    url(r'^post/$', views.PostListView.as_view(), name='management-post-list'),
    url(r'^post/verify/$', views.VerifyPostListView.as_view(), name='management-post-list-verify'),
    url(r'^post/edit/(?P<pk>\d+)/$', views.EditPostView.as_view(), name='management-post-edit'),
    url(r'^post/verify/(?P<pk>\d+)/$', views.VerifyView.as_view(), name='management-post-verify'),
    url(r'^post/ignore/(?P<pk>\d+)/$', views.IgnoreView.as_view(), name='management-post-ignore'),
    url(r'^post/hide/(?P<pk>\d+)/$', views.HideView.as_view(), name='management-post-hide'),

    url(r'^user/$', views.UserView.as_view(), name='management-user-list'),
    url(r'^user/coin/(?P<uid>\d+)/$', views.CoinView.as_view(), name='management-user-coin'),
    url(r'^user/(?P<pk>\d+)/$', views.UserDetailView.as_view(), name='management-user-detail'),
    url(r'^user/(?P<uid>\d+)/log/$', views.CoinLogView.as_view(), name='management-user-coin-log'),
    url(r'^user/(?P<pk>\d+)/ban/$', views.BanUserView.as_view(), name='management-user-ban'),

    url(r'^invitecode/$', views.InviteCodeListView.as_view(), name='management-invitecode'),
    url(r'^invitecode/generate/$', views.GenerateInvitecodeView.as_view(), name='management-generate-invitecode'),
    url(r'^invitecode/delete/(?P<pk>\d+)/$', views.DeleteInviteCodeView.as_view(), name='management-delete-invitecode'),

    url(r'^gift/$', views.GiftListView.as_view(), name='management-gift-list'),
    url(r'^gift/add/$', views.GiftAddView.as_view(), name='management-gift-add'),
    url(r'^gift/(?P<pk>\d+)/$', views.GiftEditView.as_view(), name='management-gift-edit'),
    url(r'^gift/(?P<pk>\d+)/delete/$', views.GiftDeleteView.as_view(), name='management-gift-delete'),

    url(r'^order/$', views.GiftLogListView.as_view(), name='management-order-list'),
    url(r'^order/(?P<pk>\d+)/$', views.GiftLogDetailView.as_view(), name='management-order-detail'),
    url(r'^order/wait/$', views.GiftLogWaitListView.as_view(), name='management-order-wait-list'),

    url(r'^link/$', views.LinkListView.as_view(), name='management-link-list'),
    url(r'^link/(?P<pk>\d+)/$', views.LinkEditView.as_view(), name='management-link-edit'),
    url(r'^link/(?P<pk>\d+)/delete/$', views.LinkDeleteView.as_view(), name='management-link-delete'),
    url(r'^link/add/$', views.LinkAddView.as_view(), name='management-link-add'),

    url(r'^comment/delete/(?P<pk>\d+)/$', views.DeleteCommentView.as_view(), name='management-comment-delete'),
]

mooder/urls.py
import os
from django.conf.urls import url, include
from django.conf.urls.static import static
from django.contrib import admin
from django.conf import settings

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('accounts.urls')),
    url(r'^', include('archives.urls', namespace='archive')),
    url(r'^captcha/', include('captcha.urls')),

    url(r'^management/', include('managements.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

accounts/models.py
import urllib, hashlib, os
from uuid import uuid4
from django.db import models
from django.contrib.auth.models import AbstractUser, BaseUserManager, UserManager
from django.conf import settings
from django.db.models.signals import pre_save
from django.shortcuts import reverse
from urllib.parse import urlencode
from django.dispatch import receiver
from django.forms import ValidationError
from archives.models import check_image_extension

from django.conf import settings


class MyUserManager(BaseUserManager):
    def create_user(self, email, nickname, password=None, *args, **kwargs):
        """
        Creates and saves a User with the given email, date of
        birth and password.
        """
        if not email:
            raise ValueError('Users must have an email address')

        user = self.model(
            email=self.normalize_email(email),
            nickname=nickname,
        )
        user.set_password(password)
        user.save(using=self._db)
        return user

    def create_superuser(self, email, nickname, password):
        """
        Creates and saves a superuser with the given email, date of
        birth and password.
        """
        user = self.create_user(
            email,
            password=password,
            nickname=nickname,
        )
        user.is_staff = True
        user.is_superuser = True
        user.save(using=self._db)
        return user


USER_LEVEL = [_[1] for _ in settings.USER_LEVEL_RANGE]
DEFAULT_USER_LEVEL = settings.USER_LEVEL_RANGE[0][1][0]


def generate_upload_filename(instance, filename):
    filename, ext = os.path.splitext(filename)
    filename = "%s%s" % (uuid4(), ext)
    return "mugshots/%s/%s" % (instance.id, filename)


# Create your models here.
class Member(AbstractUser):
    username = models.CharField('用户名', max_length=64, blank=True, null=True)
    email = models.EmailField('邮箱', max_length=255, unique=True)
    nickname = models.CharField('昵称', max_length=64, unique=True)
    mugshot = models.ImageField('头像', upload_to=generate_upload_filename, validators=[check_image_extension], blank=True, null=True)
    rank = models.PositiveIntegerField('Rank', default=0)
    coin = models.PositiveIntegerField('金币', default=0)
    level = models.CharField('等级', max_length=16, default=DEFAULT_USER_LEVEL, choices=USER_LEVEL)
    description = models.CharField('个人简介', max_length=512, blank=True, null=True)
    is_auditor = models.BooleanField('审核员', default=False, help_text='是否能够进入审核后台')

    objects = MyUserManager()
    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['nickname']

    class Meta:
        ordering = ['-rank', '-date_joined']

    def get_absolute_url(self):
        return reverse('archive:profile', kwargs=dict(uid=self.id))

    def get_mugshot_url(self):
        if self.mugshot:
            return self.mugshot.url
        else:
            gravatar_url = "//www.gravatar.com/avatar/" + hashlib.md5(self.email.lower().encode()).hexdigest() + "?"
            gravatar_url += urlencode({'s': '100'})
            return gravatar_url


class Invitecode(models.Model):
    code = models.CharField('邀请码', max_length=32, unique=True)
    usedby = models.OneToOneField(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, blank=True, null=True, related_name='used_by_user')
    createdby = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name='created_by_user', blank=True, null=True)
    used = models.BooleanField('使用', default=False)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)
    used_time = models.DateTimeField('使用时间', blank=True, null=True)

    class Meta:
        ordering = ['-created_time']
        verbose_name = "邀请码"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.code


@receiver(pre_save, sender=Member)
def pre_save_member_receiver(sender, instance, *args, **kwargs):
    for level in settings.USER_LEVEL_RANGE:
        level_name = level[1][0]
        if level[0][0] <= instance.rank < level[0][1] and instance.level != level_name:
            instance.level = level_name
            break

    if instance.rank >= settings.USER_LEVEL_RANGE[-1][0][0]:
        instance.level = settings.USER_LEVEL_RANGE[-1][1][0]

archives/models.py
import io, os
from datetime import datetime
from django.db import models
from django.utils.crypto import get_random_string
from django.conf import settings
from uuid import uuid4
from django.template.defaultfilters import date
from django.utils import timezone
from django.core.exceptions import ValidationError
from django.shortcuts import reverse
from django.db.models.signals import pre_save
from django.dispatch import receiver
from django.templatetags.static import static

__all__ = [
    'VERIFY_STATUS_CHOICES',
    'VISIBLE_STATUS_CHOICES',
    'LEVEL_STATUS_CHOICES',
    'Post',
    'Comment',
    'Category',
    'PostImage',
    'Link',
]

VERIFY_STATUS_CHOICES = (
    ('wait', '待审核'),
    ('pass', '通过'),
    ('failed', '未通过')
)
VISIBLE_STATUS_CHOICES = (
    ('private', '私密的'),
    ('sell', '出售的'),
    ('public', '公开的')
)
LEVEL_STATUS_CHOICES = (
    ('low', '低危'),
    ('medium', '中危'),
    ('high', '高危'),
    ('grave', '严重')
)
generate_random_filename = lambda a,b:b


def check_image_extension(field):
    _allowed_ext = ('.jpg', '.jpeg', '.png', '.bmp', '.gif')
    _, ext = os.path.splitext(field.name)
    ext = ext.lower()
    if ext not in _allowed_ext:
        raise ValidationError("图片文件只允许以下后缀： %s." % (','.join(_allowed_ext), ))


def generate_attachment_filename(instance, filename):
    filename, ext = os.path.splitext(filename)
    if ext not in ('.jpg', '.jpeg', '.png', '.bmp', '.gif', '.rar', '.gz', '.zip', '.7z', '.txt', '.pdf',
                   '.doc', '.docx', '.ppt', '.pptx', ):
        ext = '.attach'
    filename = "%s-%s%s" % (uuid4(), get_random_string(length=8), ext)

    tzinfo = timezone.get_current_timezone() if settings.USE_TZ else None
    date_dir = date(datetime.now(tz=tzinfo), 'Y/m')

    return "attachment/%s/%s" % (date_dir, filename)


def generate_image_filename(instance, filename):
    filename, ext = os.path.splitext(filename)
    filename = "%s-%s%s" % (uuid4(), get_random_string(length=8), ext)

    tzinfo = timezone.get_current_timezone() if settings.USE_TZ else None
    date_dir = date(datetime.now(tz=tzinfo), 'Y/m/d')

    return "images/%s/%s" % (date_dir, filename)


class FrontPostManager(models.Manager):
    def get_queryset(self):
        return super(FrontPostManager, self).get_queryset().filter(show=True)


# Create your models here.
class Post(models.Model):
    title = models.CharField('标题', max_length=256)
    content = models.TextField('内容', blank=True)
    description = models.TextField('简要描述', blank=True)
    verify = models.CharField('状态', max_length=8, choices=VERIFY_STATUS_CHOICES, default='wait')
    visible = models.CharField('公开度', max_length=8, choices=VISIBLE_STATUS_CHOICES, default='private')
    show = models.BooleanField('显示', default=True)
    rank = models.PositiveIntegerField('Rank', default=0)
    level = models.CharField('等级', max_length=8, choices=LEVEL_STATUS_CHOICES, default='low')
    attachment = models.FileField('附件', blank=True, upload_to=generate_attachment_filename)
    attachment_filename = models.CharField('附件文件名', blank=True, null=True, max_length=256)
    remark = models.TextField('评价', null=True, blank=True)

    price = models.PositiveIntegerField('价格', default=0)
    buyers = models.ManyToManyField(settings.AUTH_USER_MODEL, related_name='user_buy_post', blank=True)

    author = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='作者', on_delete=models.CASCADE, related_name='author_post')
    category = models.ForeignKey('Category', verbose_name='分类', on_delete=models.CASCADE)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)
    verify_time = models.DateTimeField('审核时间', blank=True, null=True)

    objects = models.Manager()
    posts = FrontPostManager()

    class Meta:
        ordering = ['-created_time']
        verbose_name = "文章"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('archive:detail', kwargs=dict(pk=self.id))

    def get_attachment_url(self):
        return reverse('archive:attachment', kwargs=dict(pk=self.id))


class Comment(models.Model):
    content = models.TextField('评论')
    post = models.ForeignKey(Post, verbose_name='文章', on_delete=models.CASCADE)
    author = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='作者', on_delete=models.CASCADE)
    parent = models.ForeignKey('self', verbose_name='父评论', blank=True, null=True)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['created_time']
        verbose_name = '评论'
        verbose_name_plural = verbose_name

    def __str__(self):
        return "%s's Comment" % self.author.nickname


@receiver(pre_save, sender=Comment)
def pre_save_comment_receiver(sender, instance, *args, **kwargs):
    if instance.parent is None:
        return

    try:
        comment = Comment.objects.get(pk=instance.parent.id)
    except Comment.DoesNotExist:
        instance.parent = None
        return

    if comment.post_id != instance.post_id:
        instance.parent = None


class Category(models.Model):
    name = models.CharField('分类名', max_length=30)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['name']
        verbose_name = "分类"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.name


class PostImage(models.Model):
    file = models.ImageField('图片', upload_to=generate_image_filename, validators=[check_image_extension], blank=True)
    name = models.CharField('文件名', blank=True, null=True, max_length=256)
    uploaded_by = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='上传者', on_delete=models.CASCADE)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    def __str__(self):
        return self.file.url


class Link(models.Model):
    title = models.CharField('名称', max_length=32)
    link = models.URLField('链接')

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['created_time']
        verbose_name = "应用链接"
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.title


class Gift(models.Model):
    name = models.CharField('名称', max_length=256)
    link = models.URLField('参考链接', null=True, blank=True)
    photo = models.ImageField('图片', upload_to=generate_image_filename,
                              validators=[check_image_extension], null=True, blank=True)
    description = models.TextField('描述', blank=True)
    price = models.PositiveIntegerField('价格')
    amount = models.PositiveIntegerField('数量', default=0)
    show = models.BooleanField('显示', default=True)

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)

    class Meta:
        ordering = ['-price']
        verbose_name = '礼物'
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.name

    def get_photo_url(self):
        if self.photo:
            return self.photo.url
        else:
            return static('img/gift.jpg')

    def get_absolute_url(self):
        return reverse('archive:gift', kwargs=dict(pk=self.id))


class GiftLog(models.Model):
    gift = models.ForeignKey(Gift, verbose_name='礼物')
    buyer = models.ForeignKey(settings.AUTH_USER_MODEL, verbose_name='购买者')
    cost = models.PositiveIntegerField('花费')
    delivery = models.BooleanField('发货', default=False)

    address = models.CharField('收货地址', max_length=512, help_text='填写收件地址，虚拟物品则填写邮箱或QQ', null=True)
    remark = models.TextField('备注', null=True, blank=True, help_text='没有则无需填写')

    created_time = models.DateTimeField('创建时间', auto_now_add=True)
    last_modify_time = models.DateTimeField('修改时间', auto_now=True)
    delivery_time = models.DateTimeField('发货时间', blank=True, null=True)

    reply = models.TextField('管理员回复', null=True, blank=True, help_text='发货订单号等')

    class Meta:
        ordering = ['-created_time']
        verbose_name = '购买记录'
        verbose_name_plural = verbose_name

    def __str__(self):
        return ""

    def get_absolute_url(self):
        return reverse('archive:order', kwargs=dict(pk=self.id))

managements/forms.py
from django import forms
from django.core.validators import MinValueValidator, MaxValueValidator
from archives.models import Post


class PostForm(forms.ModelForm):
    price = forms.IntegerField(
        validators=[MinValueValidator(0), MaxValueValidator(10)],
        max_value=10,
        min_value=0,
        label='价格',
        initial=0
    )

    def clean_price(self):
        if self.cleaned_data['visible'] == 'sell' and self.cleaned_data['price'] <= 0:
            raise forms.ValidationError('出售的贡献必须填写价格')
        return self.cleaned_data['price']

    class Meta:
        model = Post
        fields = [
            'title',
            'category',
            'visible',
            'price',
            'level',
            'description',
            'content',
            'attachment',
            'remark',
        ]

templates/management/_pagination.html
<nav class="pull-right">
<ul class="pagination pagination-sm">
  {% if page_obj.has_previous %}
      <li><a href="?page={{ page_obj.previous_page_number }}">&laquo;</a></li>
  {% else %}
      <li class="disabled"><span>&laquo;</span></li>
  {% endif %}

  {% for page in page_obj.pages %}
    {% if page %}
    <li {% ifequal page_obj.number page %}class="active"{% endifequal %}><a href="?page={{ page }}">{{ page }}</a></li>
    {% else %}
    <li class="disabled"><span>...</span></li>
    {% endif %}
  {% endfor %}

  {% if page_obj.has_next %}
      <li><a href="?page={{ page_obj.next_page_number }}">&raquo;</a></li>
  {% else %}
      <li class="disabled"><span>&raquo;</span></li>
  {% endif %}
</ul>
</nav>

templates/management/coin.html
{% extends 'management/base.html' %}
{% load bootstrap3 %}

{% block subject %}积分操作{% endblock %}

{% block body %}
<form method="post" class="form" enctype="multipart/form-data">
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
        <a href="javascript:history.back(-1)" class="btn btn-info">返回</a>
        <button type="submit" class="btn btn-primary">
             <span class="fa-star fa"></span> 提交
        </button>
    {% endbuttons %}
</form>
{% endblock %}

templates/management/gift_edit.html
{% extends 'management/base.html' %}
{% load bootstrap3 %}

{% block subject %}礼物{% endblock %}

{% block body %}
<form method="post" class="form" enctype="multipart/form-data">
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
        <a href="javascript:history.back(-1)" class="btn btn-info">返回</a>
        <button type="submit" class="btn btn-primary">
             <span class="fa-star fa"></span> 提交
        </button>
    {% endbuttons %}
</form>
{% endblock %}

templates/management/gift_list.html
{% extends 'management/base.html' %}
{% load admin_helper %}

{% block subject %}礼物{% endblock %}

{% block body %}
<a href="{% url 'management-gift-add' %}" class="btn btn-primary btn-sm">增加</a>
<hr>
<table class="table table-hover">
    <thead>
        <tr>
            <th>名称</th>
            <th>价格</th>
            <th>数量</th>
            <th>参考链接</th>
            <th>动作</th>
        </tr>
    </thead>
    <tbody>
    {% for object in object_list %}
        <tr>
            <td><a href="{{ object.get_absolute_url }}" target="_blank" class="link-muted">{{ object.name }}</a></td>
            <td>{{ object.price }}</td>
            <td>{{ object.amount }}</td>
            <td><a href="{{ object.link }}" target="_blank">访问链接</a></td>
            <td>
                <a href="{% url 'management-gift-edit' pk=object.id %}" class="btn btn-primary btn-xs" role="button">编辑</a>
                <a href="javascript:submit('{% url 'management-gift-delete' pk=object.id %}')" class="btn btn-danger btn-xs confirm-alert" role="button">删除</a>
            </td>
        </tr>
    {% endfor %}
    </tbody>
</table>
    {% include 'management/_pagination.html' %}
{% endblock %}

templates/management/ignore_post.html
{% extends 'management/base.html' %}
{% load bootstrap3 %}

{% block subject %}忽略贡献 《{{ post.title }}》{% endblock %}

{% block body %}
<form method="post" class="form" enctype="multipart/form-data">
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
        <a href="javascript:history.back(-1)" class="btn btn-info">返回</a>
        <button type="submit" class="btn btn-primary">
             <span class="fa-star fa"></span> 忽略
        </button>
    {% endbuttons %}
</form>
{% endblock %}

templates/management/invitecode_list.html
{% extends 'management/base.html' %}
{% load admin_helper %}

{% block subject %}邀请码列表{% endblock %}

{% block body %}
<a href="javascript:submit('{% url 'management-generate-invitecode' %}');" class="btn btn-primary btn-sm">生成</a>
    <hr>
<table class="table table-hover">
    <thead>
        <tr>
            <th>生成时间</th>
            <th>使用时间</th>
            <th>邀请码</th>
            <th>生成人</th>
            <th>使用者</th>
            <th>使用</th>
            <th>动作</th>
        </tr>
    </thead>
    <tbody>
    {% for code in object_list %}
        <tr>
            <td>{{ code.created_time | date:"Y-m-d H:i:s" }}</td>
            <td>{{ code.used_time | date:"Y-m-d H:i:s" | default:"尚未使用" }}</td>
            <td>
                {% if not code.used %}
                <span class="text-success">{{ code.code }}</span>
                {% else %}
                <span class="text-danger">{{ code.code }}</span>
                {% endif %}
            </td>
            <td><a href="{{ code.createdby.get_absolute_url }}" target="_blank">{{ code.createdby.nickname }}</a></td>
            <td><a href="{{ code.usedby.get_absolute_url | default:"javascript:;" }}" target="_blank">{{ code.usedby.nickname | default:"尚未使用" }}</a></td>
            <td>{{ code.used | yesno:"是,否" }}</td>
            <td>
                {% if not code.used %}
                <a href="javascript:submit('{% url 'management-delete-invitecode' pk=code.id %}');" class="btn btn-danger btn-xs confirm-alert" role="button">删除</a>
                {% endif %}
            </td>
        </tr>
    {% endfor %}
    </tbody>
</table>
    {% include 'management/_pagination.html' %}
{% endblock %}

templates/management/link_list.html
{% extends 'management/base.html' %}
{% load admin_helper %}

{% block subject %}链接列表{% endblock %}

{% block body %}
<a href="{% url 'management-link-add' %}" class="btn btn-primary btn-sm">增加</a>
<hr>
<table class="table table-hover">
    <thead>
        <tr>
            <th>名称</th>
            <th>链接</th>
            <th>动作</th>
        </tr>
    </thead>
    <tbody>
    {% for object in object_list %}
        <tr>
            <td>{{ object.title }}</td>
            <td><a href="{{ object.link }}" target="_blank">{{ object.link }}</a></td>
            <td>
                <a href="{% url 'management-link-edit' pk=object.id %}" class="btn btn-primary btn-xs" role="button">编辑</a>
                <a href="javascript:submit('{% url 'management-link-delete' pk=object.id %}')" class="btn btn-danger btn-xs confirm-alert" role="button">删除</a>
            </td>
        </tr>
    {% endfor %}
    </tbody>
</table>
    {% include 'management/_pagination.html' %}
{% endblock %}

templates/management/post.html
{% extends 'management/base.html' %}
{% load admin_helper %}

{% block subject %}贡献列表{% endblock %}

{% block body %}
<table class="table table-hover">
    <thead>
        <tr>
            <th>作者</th>
            <th>标题</th>
            <th>状态</th>
            <th>公开</th>
            <th>等级</th>
            <th>Rank</th>
            <th>时间</th>
            <th>动作</th>
        </tr>
    </thead>
    <tbody>
    {% for post in post_list %}
        <tr>
            <td><a href="{% url 'management-user-detail' pk=post.author.id %}" class="link-muted">{{ post.author.nickname }}</a></td>
            <td><a class="link-muted" href="{{ post.get_absolute_url }}" target="_blank">{{ post.title }}</a></td>
            <td>{{ post.get_verify_display }}</td>
            <td>{{ post.get_visible_display }}</td>
            <td>{{ post.get_level_display | post_tag }}</td>
            <td>{{ post.rank }}</td>
            <td>{{ post.created_time | date:'Y-m-d H:i' }}</td>
            <td>
                {% if post.verify == 'wait' %}
                <a href="{% url 'management-post-verify' pk=post.id %}" class="btn btn-success btn-xs" role="button">审核</a>
                <a href="{% url 'management-post-ignore' pk=post.id %}" class="btn btn-warning btn-xs" role="button">忽略</a>
                {% endif %}
                <a href="{% url 'management-post-edit' pk=post.id %}" class="btn btn-primary btn-xs" role="button">编辑</a>
                <a href="javascript:submit('{% url 'management-post-hide' pk=post.id %}')" class="btn btn-danger btn-xs confirm-alert" role="button">删除</a>
            </td>
        </tr>
    {% endfor %}
    </tbody>
</table>
    <form action="" method="post">
        <input type="hidden" name="">
    </form>
    {% include 'management/_pagination.html' %}
{% endblock %}

templates/management/post_verify.html
{% extends 'management/base.html' %}
{% load bootstrap3 %}

{% block subject %}编辑文章 《{{ post.title }}》{% endblock %}

{% block body %}
<form method="post" class="form" enctype="multipart/form-data">
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
        <a href="javascript:history.back(-1)" class="btn btn-info">返回</a>
        <button type="submit" class="btn btn-primary">
             <span class="fa-star fa"></span> 审核
        </button>
    {% endbuttons %}
</form>
{% endblock %}

templates/management/user.html
{% extends 'management/base.html' %}
{% load admin_helper %}

{% block subject %}用户列表{% endblock %}

{% block body %}
<table class="table table-hover">
    <thead>
        <tr>
            <th>昵称</th>
            <th>邮箱</th>
            <th>等级</th>
            <th>RANK</th>
            <th>动作</th>
        </tr>
    </thead>
    <tbody>
    {% for user in object_list %}
        <tr>
            <td><a href="{% url 'management-user-detail' pk=user.id %}">{{ user.nickname }}</a></td>
            <td>{{ user.email }}</td>
            <td>{{ user.get_level_display | whitehat_tag }}</td>
            <td>{{ user.rank }}</td>
            <td>
                <a href="{% url 'management-user-detail' pk=user.id %}" class="btn btn-primary btn-xs" role="button">详情</a>
                <a href="{% url 'management-user-coin' uid=user.id %}" class="btn btn-success btn-xs" role="button">奖惩</a>
                <a href="{% url 'management-user-coin-log' uid=user.id %}" class="btn btn-info btn-xs" role="button">金币日志</a>
                <a href="{{ user.get_absolute_url }}" target="_blank" class="btn btn-warning btn-xs">前台</a>
                {% if user.is_active %}
                <a href="javascript:submit('{% url 'management-user-ban' pk=user.id %}')" target="_blank" class="btn btn-danger btn-xs confirm-alert">禁用</a>
                {% else %}
                <a href="javascript:submit('{% url 'management-user-ban' pk=user.id %}')" target="_blank" class="btn btn-default btn-xs confirm-alert">启用</a>
                {% endif %}
            </td>
        </tr>
    {% endfor %}
    </tbody>
</table>
    {% include 'management/_pagination.html' %}
{% endblock %}